#include <u.h>
#include <libc.h>
#include "der.h"

char *Asn1Errstr[] = {
	[ASN_OK]				"no error",
	[ASN_ESHORT]			"no room in buffer",
	[ASN_ETOOBIG]			"value too large",
	[ASN_EVALLEN]			"value too long",
	[ASN_ECONSTR]			"ADT when primitave expected",
	[ASN_EPRIM]				"primitive when ADT expected",
	[ASN_EINVAL]			"invalid value",
	[ASN_EUNIMPL]			"unimplemented"
};


void *
der_malloc(int n)
{
	void *p;
	if(n==0)
		n=1;
	p = mallocz(n, 1);
	if(p == nil)
		sysfatal("der: no memory, %r");
	setmalloctag(p, getcallerpc(&n));
	return p;
}

char*
der_strdup(char *s)
{
	char *d;
	int n;

	n = strlen(s)+1;
	d = der_malloc(n);
	memmove(d, s, n);
	return d;
}

